version: '2'

services:
  user-ca:
    container_name: user-ca
    extends:
      file: ./ca-base.yaml
      service: ca-base
    image: user-ca
    ports:
      - 7001:7054

  bike-ca:
    container_name: bike-ca
    extends:
      file: ./ca-base.yaml
      service: ca-base
    image: bike-ca
    ports:
      - 7002:7054

  company-ca:
    container_name: company-ca
    extends:
      file: ./ca-base.yaml
      service: ca-base
    image: company-ca
    ports:
      - 7003:7054

  repairshop-ca:
    container_name: repairshop-ca
    extends:
      file: ./ca-base.yaml
      service: ca-base
    image: repairshop-ca
    ports:
      - 7004:7054

  orderer0:
    container_name: orderer0
    image: orderer
    environment:
      - ORDERER_GENERAL_LOGLEVEL=debug
      - ORDERER_GENERAL_LISTENADDRESS=0.0.0.0
      - ORDERER_GENERAL_GENESISMETHOD=file
      - ORDERER_GENERAL_GENESISFILE=/orderer/crypto/genesis.block
      - ORDERER_GENERAL_LOCALMSPID=OrdererMSP
      - ORDERER_GENERAL_LOCALMSPDIR=/orderer/crypto/msp
      - ORDERER_GENERAL_TLS_ENABLED=true
      - ORDERER_GENERAL_TLS_PRIVATEKEY=/orderer/crypto/tls/server.key
      - ORDERER_GENERAL_TLS_CERTIFICATE=/orderer/crypto/tls/server.crt
      - ORDERER_GENERAL_TLS_ROOTCAS=[/orderer/crypto/tls/ca.crt]
    working_dir: /orderer
    command: orderer
    ports:
      - 7050:7050

  user-peer:
    container_name: user-peer
    extends:
      file: ./peer-base.yaml
      service: peer-base
    image: bike-peer
    environment:
      - CORE_PEER_ID=user-peer
      - CORE_PEER_ADDRESS=user-peer:7051
      - CORE_PEER_GOSSIP_EXTERNALENDPOINT=user-peer:7051
      - CORE_PEER_LOCALMSPID=UserOrgMSP
    ports:
      - 8001:7051
      - 8101:7053
    depends_on:
      - orderer0

  bike-peer:
    container_name: bike-peer
    extends:
      file: ./peer-base.yaml
      service: peer-base
    image: bike-peer
    environment:
      - CORE_PEER_ID=bike-peer
      - CORE_PEER_ADDRESS=bike-peer:7051
      - CORE_PEER_GOSSIP_EXTERNALENDPOINT=bike-peer:7051
      - CORE_PEER_LOCALMSPID=BikeOrgMSP
    ports:
      - 8002:7051
      - 8102:7053
    depends_on:
      - orderer0

  company-peer:
    container_name: company-peer
    extends:
      file: ./peer-base.yaml
      service: peer-base
    image: shop-peer
    environment:
      - CORE_PEER_ID=company-peer
      - CORE_PEER_ADDRESS=company-peer:7051
      - CORE_PEER_GOSSIP_EXTERNALENDPOINT=company-peer:7051
      - CORE_PEER_LOCALMSPID=CompanyOrgMSP
    ports:
      - 8003:7051
      - 8103:7053
    depends_on:
      - orderer0

  repairshop-peer:
    container_name: repairshop-peer
    extends:
      file: ./peer-base.yaml
      service: peer-base
    image: repairshop-peer
    environment:
      - CORE_PEER_ID=repairshop-peer
      - CORE_PEER_ADDRESS=repairshop-peer:7051
      - CORE_PEER_GOSSIP_EXTERNALENDPOINT=repairshop-peer:7051
      - CORE_PEER_LOCALMSPID=RepairshopOrgMSP
    ports:
      - 8004:7051
      - 8104:7053
    depends_on:
      - orderer0

  app:
    build:
      context: ./app
    container_name: app
    environment:
      - PORT=3000
      - DOCKER_SOCKET_PATH=/host/var/run/docker.sock
      - DOCKER_CCENV_IMAGE=hyperledger/fabric-ccenv:latest
    ports:
      - 3000:3000
    volumes:
      - /var/run/:/host/var/run/
      - ./app:/app
    depends_on:
      - orderer0
      - user-ca
      - user-peer
      - bike-ca
      - bike-peer
      - company-ca
      - company-peer
      - repairshop-ca
      - repairshop-peer

volumes:
  biker-app:
    external: false
